#!/bin/bash

# This Bash script is part of the ImpBench suite and its use is threefold:
# + To initialize the included package (benchmarks are built) and perform sanity checks.
# + To enable batch-mode execution of the various benchmarks on different inputs. A demo run
#   is included under the "Tests" segment.
# + To clean the build and any generated output files.
# 
# Christos Strydis, CE Lab, TU Delft, 2009. All rights reserved (C).


##################################################################################################
######################### COMMAND-LINE ARGUMENT PARSING ##########################################

# if no arguments have been passed, print the help message anyhow
if [ $# -eq 0 ]; then
	echo #
	echo "For help on syntax, run the script with the \"-he\" flag."
	echo #
	exit -9
fi

while [ $# -gt 0 ]
do
	case $1 in
	-sc)
		flag_sc="on"
		shift 1
		;;
	-bb)
		flag_bb="on"
		shift 1
		;;
	-re)
		flag_re="on"
		shift 1
		;;
	-cb)
		flag_cb="on"
		shift 1
		;;
	-co)
		flag_co="on"
		shift 1
		;;
	-ca)
		flag_ca="on"
		shift 1
		;;
	-da)
		flag_da="on"
		shift 1
		;;
	*)
		echo #
		echo "Welcome to the ImpBench initialization script. Run it with one or more of the below arguments:"
		echo "  -he: Print this Help message and Exit."
		echo "  -sc: Perform Sanity Check (i.e. benchmarks, input datasets, paths are correctly set)."
		echo "  -bb: Build all benchmark Binaries (under 'benchmarks' directory)."
		echo "  -re: Run all created Examples (edit the 'init.sh' file to edit them)."
		echo "  -cb: Clear all built benchmark Binaries"
		echo "  -co: Clear all Output files (under 'files_output' directory) generated by example runs."
		echo "  -ca: Clear All built benchmark binaries and all output files. [Equivalent to -cb -co]"
		echo "  -da: Do All useful tasks (i.e. do sanity check, run examples, purge interim files). [Equivalent to -sc -bb -re -cb]"
		echo #
		exit -9
		;;
	esac
done

##################################################################################################
################################ INITIALIZATION TASKS ############################################

# Set compiler paths
NATIVE_GCC="gcc"
ARMCROSS_GCC="arm-linux-gcc"

# Set active GCC
ACTIVE_GCC=$NATIVE_GCC

echo #
echo "---- GCC used: $ACTIVE_GCC ----"

# Set and check working directories
TOPPATH="$PWD"
BENCH_PATH="$TOPPATH/benchmarks"
INFILE_PATH="$TOPPATH/files_input"
OUTFILE_PATH="$TOPPATH/files_output"

echo #
echo "---- Top working directory: $TOPPATH ----"
echo #
echo "---- Benchmark directory: $BENCH_PATH ----"
echo #
echo "---- Input-file directory: $INFILE_PATH ----"
echo #
echo "---- Output-file directory: $OUTFILE_PATH ----"


if [ "$flag_sc" = "on" ]; then # sanity check
	if [ ! -e "$BENCH_PATH" ]; then
		echo #
		echo "-- Benchmark directory '$BENCH_PATH' not found!"
		exit -1
	fi

	if [ ! -e "$INFILE_PATH" ]; then
		echo #
		echo "-- Input-dataset directory '$INFILE_PATH' not found!"
		exit -1
	fi

	if [ ! -e "$OUTFILE_PATH" ]; then
		echo #
		echo "-- Output-dataset directory '$OUTFILE_PATH' not found!"
		exit -1
	fi
fi # sanity check


# Set and check binary input datasets
dataset01bin=( "AEP_01.bin" "BP_01.bin" "ECGI_01.bin" "EEGI_01.bin" "EMGII_01.bin" "PFI_01.bin" "RCI_01.bin" )
dataset10bin=( "AEP_10.bin" "BP_10.bin" "ECGI_10.bin" "EEGI_10.bin" "EMGII_10.bin" "PFI_10.bin" "RCI_10.bin" )

if [ "$flag_sc" = "on" ]; then # sanity check
	for i in `seq 0 6`; do
		if [ ! -e "$INFILE_PATH/${dataset01bin[i]}" ]; then
			echo #
			echo "-- Input dataset ${dataset01bin[i]} not found!"
			#exit -2
		fi
	done

	for i in `seq 0 6`; do
		if [ ! -e "$INFILE_PATH/${dataset10bin[i]}" ]; then
			echo #
			echo "-- Input dataset ${dataset10bin[i]} not found!"
			#exit -2
		fi
	done
fi # sanity check


# Set and check ASCII input datasets
dataset01ascii=( "AEP_01.ascii" "BP_01.ascii" "ECGI_01.ascii" "EEGI_01.ascii" "EMGII_01.ascii" "PFI_01.ascii" "RCI_01.ascii" )
dataset10ascii=( "AEP_10.ascii" "BP_10.ascii" "ECGI_10.ascii" "EEGI_10.ascii" "EMGII_10.ascii" "PFI_10.ascii" "RCI_10.ascii" )

if [ "$flag_sc" = "on" ]; then # sanity check
	for i in `seq 0 6`; do
		if [ ! -e "$INFILE_PATH/${dataset01ascii[i]}" ]; then
			echo #
			echo "-- Input dataset ${dataset01ascii[i]} not found!"
			#exit -2
		fi
	done

	for i in `seq 0 6`; do
		if [ ! -e "$INFILE_PATH/${dataset10ascii[i]}" ]; then
			echo #
			echo "-- Input dataset ${dataset10ascii[i]} not found!"
			#exit -2
		fi
	done
fi # sanity check


# Set and check benchmarks
benchset=( "mlzo" "fin" "misty1" "rc6" "csum" "crc32" "motion" "dmu" )

# Build benchmark binaries
for i in `seq 0 7`; do
	if [ "$flag_bb" = "on" ]; then # build benchmarks
		if [ -e "$BENCH_PATH/${benchset[i]}" ]; then
			eval 'cd $BENCH_PATH/${benchset[i]}'
			echo #
			echo "---- Building benchmark: ${benchset[i]} ----"
			eval 'make clean'
			eval 'make MYCC=$ACTIVE_GCC'
			eval 'cd $TOPPATH'
		fi
	fi # build benchmarks

	if [ "$flag_sc" = "on" ]; then # sanity check
		if [ ! -e "$BENCH_PATH/${benchset[i]}" ]; then
			echo #
			echo "Benchmark ${benchset[i]} not found!"
			#exit -3
		fi
	fi # sanity check
done

echo #
echo "---- Initialization finished! ----"
echo #

##################################################################################################
################################ TEST RUNS #######################################################

if [ "$flag_re" = "on" ]; then # run examples
	# go to top-working directory
	eval `cd $TOPPATH`

	# compression test01: > ./benchmarks/mlzo/mlzo ./files_input/AEP_10.asci ./files_output/test01.out
	$BENCH_PATH/${benchset[0]}/${benchset[0]} $INFILE_PATH/${dataset10ascii[0]} $OUTFILE_PATH/"test01.out" > $OUTFILE_PATH/"test01.stdout"

	# compression test02: > ./benchmarks/fin/fin c ./files_input/AEP_10.asci ./files_output/test02.out
	$BENCH_PATH/${benchset[1]}/${benchset[1]} c $INFILE_PATH/${dataset10ascii[0]} $OUTFILE_PATH/"test02.out" > $OUTFILE_PATH/"test02.stdout"

	# encryption test03: > ./benchmarks/misty1/misty1 ./files_input/AEP_10.asci ./files_output/test03.out 8 "0123456789abcdef"
	$BENCH_PATH/${benchset[2]}/${benchset[2]} $INFILE_PATH/${dataset10ascii[0]} $OUTFILE_PATH/"test03.out" 8 "0123456789abcdef" > $OUTFILE_PATH/"test03.stdout"

	# encryption test04: > ./benchmarks/rc6/rc6 ./files_input/AEP_10.asci ./files_output/test04.out  16 "0123456789abcdef"
	$BENCH_PATH/${benchset[3]}/${benchset[3]} $INFILE_PATH/${dataset10ascii[0]} $OUTFILE_PATH/"test04.out"  16 "0123456789abcdef" > $OUTFILE_PATH/"test04.stdout"

	# data-integrity test05: >./benchmarks/csum/csum ./files_input/AEP_10.asci ./files_output/test05.out
	$BENCH_PATH/${benchset[4]}/${benchset[4]} $INFILE_PATH/${dataset10ascii[0]} $OUTFILE_PATH/"test05.out" > $OUTFILE_PATH/"test05.stdout"

	# data-integrity test06: > ./benchmarks/crc32/crc32 ./files_input/AEP_10.asci ./files_output/test06.out
	$BENCH_PATH/${benchset[5]}/${benchset[5]} $INFILE_PATH/${dataset10ascii[0]} $OUTFILE_PATH/"test06.out" > $OUTFILE_PATH/"test06.stdout"

	# real-app test07: > ./benchmarks/motion/motion ./files_input/AEP_10.asci ./files_output/test07.out
	$BENCH_PATH/${benchset[6]}/${benchset[6]} $INFILE_PATH/${dataset10ascii[0]} $OUTFILE_PATH/"test07.out" > $OUTFILE_PATH/"test07.stdout"

	# real-app test08: > ./benchmarks/dmu/dmu ./benchmarks/dmu/pressure.txt ./benchmarks/dmu/temperature.txt ./benchmarks/dmu/current.txt ./files_output/test08.out
	$BENCH_PATH/${benchset[7]}/${benchset[7]} $BENCH_PATH/${benchset[7]}/pressure.txt $BENCH_PATH/${benchset[7]}/temperature.txt $BENCH_PATH/${benchset[7]}/current.txt $OUTFILE_PATH/"test08.out" > $OUTFILE_PATH/"test08.stdout"
fi # run examples


##################################################################################################
################################ HOUSEKEEPING TASKS ##############################################

# Clean benchmark binaries
if ([ "$flag_cb" = "on" ]||[ "$flag_da" = "on" ]); then # clear benchmarks
	for i in `seq 0 7`; do
		if [ -e "$BENCH_PATH/${benchset[i]}" ]; then
			eval 'cd $BENCH_PATH/${benchset[i]}'
			eval 'make clean'
			eval 'cd $TOPPATH'
		fi
	done

	echo #
	echo "---- Benchmark clean-up finished! ----"
fi # clear benchmarks


# Clean program-generated output files
if ([ "$flag_co" = "on" ]||[ "$flag_da" = "on" ]); then # clear output files
	eval 'cd $OUTFILE_PATH'
	rm -rf *

	echo #
	echo "---- Output-file clean-up finished! ----"
fi # clear output files


echo #
echo "---- Script finished successfully! ----"
echo #
exit 0

